// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SendMail.pas' rev: 5.00

#ifndef SendMailHPP
#define SendMailHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <smThread.hpp>	// Pascal unit
#include <TextTemplateConverter.hpp>	// Pascal unit
#include <WinSock.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Sendmail
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMTPPriority { mpHighest, mpHigh, mpNormal, mpLow, mpLowest };
#pragma option pop

#pragma option push -b-
enum TSMTPAttachType { atNormal, atEmbedded };
#pragma option pop

#pragma option push -b-
enum TSMTPContentType { ctPlainText, ctHTML };
#pragma option pop

typedef void __fastcall (__closure *TSMTPCantAttachEvent)(System::TObject* Sender, const AnsiString 
	FileName);

typedef void __fastcall (__closure *TSMTPProgressEvent)(System::TObject* Sender, int MessageSize, int 
	BytesSent, Byte PercentsDone);

typedef void __fastcall (__closure *TSMTPResponseEvent)(System::TObject* Sender, int Code, const AnsiString 
	Response);

class DELPHICLASS TSocketHelper;
class PASCALIMPLEMENTATION TSocketHelper : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FSock;
	bool __fastcall GetIsActive(void);
	
public:
	__fastcall virtual ~TSocketHelper(void);
	virtual bool __fastcall Connect(const AnsiString Host, int Port);
	void __fastcall Disconnect(void);
	int __fastcall Send(void *Buf, int Len);
	bool __fastcall SendStr(AnsiString Str);
	int __fastcall Receive(void *Buf, int Len);
	bool __fastcall ReceiveStr(AnsiString &Str, int ExpectedSize);
	int __fastcall ReceiveResponse(AnsiString &Str, int ExpectedSize);
	__property int Sock = {read=FSock, nodefault};
	__property bool IsActive = {read=GetIsActive, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSocketHelper(void) : System::TObject() { }
	#pragma option pop
	
};


class DELPHICLASS TSMTPData;
class PASCALIMPLEMENTATION TSMTPData : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TSocketHelper* SockHelper;
	Classes::TMemoryStream* Stream;
	int ResponseCode;
	AnsiString ResponseStr;
	
public:
	__fastcall TSMTPData(void);
	__fastcall virtual ~TSMTPData(void);
};


class DELPHICLASS TSendMailAuthentication;
class PASCALIMPLEMENTATION TSendMailAuthentication : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	AnsiString FUsername;
	AnsiString FPassword;
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=0};
	__property AnsiString Username = {read=FUsername, write=FUsername};
	__property AnsiString Password = {read=FPassword, write=FPassword};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSendMailAuthentication(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSendMailAuthentication(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class DELPHICLASS TSendMail;
class PASCALIMPLEMENTATION TSendMail : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TSendMailAuthentication* FAuthentication;
	AnsiString FSMTPHost;
	int FSMTPPort;
	TSMTPContentType FMsgContentType;
	AnsiString FMsgContentCharset;
	AnsiString FMsgSubject;
	AnsiString FMsgBody;
	System::TDateTime FMsgDateTime;
	TSMTPPriority FMsgPriority;
	Texttemplateconverter::TTextTemplateConverter* FTemplateConverter;
	bool FThreaded;
	AnsiString FAgent;
	AnsiString FFromAddress;
	AnsiString FFromName;
	AnsiString FFromOrganization;
	AnsiString FTo;
	AnsiString FToCC;
	AnsiString FToBCC;
	AnsiString FReplyTo;
	Classes::TStrings* FAddHeaders;
	Classes::TStrings* FAttach;
	TSMTPAttachType FAttachType;
	Classes::TThreadPriority FThreadPriority;
	bool FWaitThread;
	int FWaitTimeout;
	TSMTPProgressEvent FOnProgress;
	TSMTPResponseEvent FOnResponse;
	Classes::TNotifyEvent FOnSuccess;
	Classes::TNotifyEvent FOnAborted;
	Classes::TNotifyEvent FOnAnyError;
	TSMTPCantAttachEvent FOnCantAttach;
	Classes::TNotifyEvent FOnConnLost;
	Classes::TNotifyEvent FOnHostUnreachable;
	TSMTPResponseEvent FOnSMTPError;
	Smthread::TsmThreadWaitTimeoutExpired FOnWaitTimeoutExpired;
	bool FBusy;
	bool FRealBusy;
	Smthread::TCustomThread* FThread;
	TSMTPData* FActiveSMTPData;
	int CantAttachFileIndex;
	void __fastcall SetAddHeaders(Classes::TStrings* Value);
	void __fastcall SetAttach(Classes::TStrings* Value);
	void __fastcall SetTemplateConverter(Texttemplateconverter::TTextTemplateConverter* Value);
	bool __fastcall GetThreadBusy(void);
	bool __fastcall IsNotLocalHost(void);
	bool __fastcall IsNotDefaultContentCharset(void);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* aComponent, Classes::TOperation aOperation
		);
	void __fastcall ProduceMessage(const Classes::TStream* Stream, bool ToFile, bool Unsent);
	void __fastcall SendMessage(void);
	void __fastcall ReleaseSMTPStream(void);
	void __fastcall ThreadExecute(System::TObject* Sender);
	void __fastcall ThreadException(System::TObject* Sender);
	void __fastcall ThreadTerminate(System::TObject* Sender);
	void __fastcall ThreadWaitTimeoutExpired(System::TObject* Sender, bool &TerminateThread);
	void __fastcall DoHostUnreachable(void);
	void __fastcall DoSuccess(void);
	void __fastcall DoSMTPResponse(int ResponseCode, const AnsiString ResponseStr);
	void __fastcall DoSMTPError(int ErrorCode, const AnsiString ErrorStr);
	void __fastcall DoProgress(Classes::TMemoryStream* Stream);
	void __fastcall DoConnLost(void);
	void __fastcall SyncCantAttach(void);
	void __fastcall SyncHostUnreachable(void);
	void __fastcall SyncSuccess(void);
	void __fastcall SyncSMTPResponse(void);
	void __fastcall SyncSMTPError(void);
	void __fastcall SyncProgress(void);
	void __fastcall SyncConnLost(void);
	
public:
	__fastcall virtual TSendMail(Classes::TComponent* aOwner);
	__fastcall virtual ~TSendMail(void);
	bool __fastcall Send(void);
	bool __fastcall SaveToFile(const AnsiString FileName, bool Unsent);
	void __fastcall Abort(bool HardTerminate);
	__property bool Busy = {read=FBusy, nodefault};
	__property bool ThreadBusy = {read=GetThreadBusy, nodefault};
	__property Smthread::TCustomThread* Thread = {read=FThread};
	
__published:
	__property TSendMailAuthentication* Authentication = {read=FAuthentication, write=FAuthentication};
		
	__property AnsiString SMTPHost = {read=FSMTPHost, write=FSMTPHost, stored=IsNotLocalHost};
	__property int SMTPPort = {read=FSMTPPort, write=FSMTPPort, default=25};
	__property AnsiString MsgContentCharset = {read=FMsgContentCharset, write=FMsgContentCharset, stored=
		IsNotDefaultContentCharset};
	__property TSMTPContentType MsgContentType = {read=FMsgContentType, write=FMsgContentType, default=0
		};
	__property System::TDateTime MsgDateTime = {read=FMsgDateTime, write=FMsgDateTime};
	__property AnsiString MsgSubject = {read=FMsgSubject, write=FMsgSubject};
	__property AnsiString MsgBody = {read=FMsgBody, write=FMsgBody};
	__property TSMTPPriority MsgPriority = {read=FMsgPriority, write=FMsgPriority, default=2};
	__property AnsiString Agent = {read=FAgent, write=FAgent};
	__property Classes::TStrings* AddHeaders = {read=FAddHeaders, write=SetAddHeaders};
	__property Classes::TStrings* Attach = {read=FAttach, write=SetAttach};
	__property TSMTPAttachType AttachType = {read=FAttachType, write=FAttachType, default=0};
	__property AnsiString FromAddress = {read=FFromAddress, write=FFromAddress};
	__property AnsiString FromName = {read=FFromName, write=FFromName};
	__property AnsiString FromOrganization = {read=FFromOrganization, write=FFromOrganization};
	__property AnsiString ToAddr = {read=FTo, write=FTo};
	__property AnsiString ToCC = {read=FToCC, write=FToCC};
	__property AnsiString ToBCC = {read=FToBCC, write=FToBCC};
	__property AnsiString ReplyTo = {read=FReplyTo, write=FReplyTo};
	__property Texttemplateconverter::TTextTemplateConverter* TemplateConverter = {read=FTemplateConverter
		, write=SetTemplateConverter};
	__property bool Threaded = {read=FThreaded, write=FThreaded, default=1};
	__property Classes::TThreadPriority ThreadPriority = {read=FThreadPriority, write=FThreadPriority, 
		default=3};
	__property bool WaitThread = {read=FWaitThread, write=FWaitThread, default=0};
	__property int WaitTimeout = {read=FWaitTimeout, write=FWaitTimeout, default=0};
	__property TSMTPProgressEvent OnProgress = {read=FOnProgress, write=FOnProgress};
	__property TSMTPResponseEvent OnResponse = {read=FOnResponse, write=FOnResponse};
	__property Classes::TNotifyEvent OnSuccess = {read=FOnSuccess, write=FOnSuccess};
	__property Classes::TNotifyEvent OnAborted = {read=FOnAborted, write=FOnAborted};
	__property Classes::TNotifyEvent OnAnyError = {read=FOnAnyError, write=FOnAnyError};
	__property TSMTPCantAttachEvent OnCantAttach = {read=FOnCantAttach, write=FOnCantAttach};
	__property Classes::TNotifyEvent OnConnLost = {read=FOnConnLost, write=FOnConnLost};
	__property Classes::TNotifyEvent OnHostUnreachable = {read=FOnHostUnreachable, write=FOnHostUnreachable
		};
	__property TSMTPResponseEvent OnSMTPError = {read=FOnSMTPError, write=FOnSMTPError};
	__property Smthread::TsmThreadWaitTimeoutExpired OnWaitTimeoutExpired = {read=FOnWaitTimeoutExpired
		, write=FOnWaitTimeoutExpired};
};


//-- var, const, procedure ---------------------------------------------------
#define LOCALHOST_STR "localhost"
#define DEF_CONTENT_CHARSET "iso-8859-1"
extern PACKAGE bool __fastcall QuickSendMail(const AnsiString FromAddr, const AnsiString FromName, const 
	AnsiString ToAddr, const AnsiString ToName, const AnsiString Subject, const AnsiString Body, const 
	AnsiString SMTPHost, Word SMTPPort, TSMTPContentType ContentType, TSMTPPriority Priority, const AnsiString 
	ContentCharset, bool RunInSeparateThread);
extern PACKAGE void __fastcall Register(void);

}	/* namespace Sendmail */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Sendmail;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SendMail
